Index: tmp/org.txm.backtomedia.rcp/src/org/txm/backtomedia/editors/vlcplayer/VLCPlayer.java
===================================================================
--- tmp/org.txm.backtomedia.rcp/src/org/txm/backtomedia/editors/vlcplayer/VLCPlayer.java	(revision 2420)
+++ tmp/org.txm.backtomedia.rcp/src/org/txm/backtomedia/editors/vlcplayer/VLCPlayer.java	(revision 2421)
@@ -1,14 +1,10 @@
 package org.txm.backtomedia.editors.vlcplayer;
 
-import java.awt.Canvas;
-import java.awt.Frame;
 import java.io.File;
 import java.time.LocalTime;
 import java.time.format.DateTimeFormatter;
-import java.util.List;
 
 import org.eclipse.swt.SWT;
-import org.eclipse.swt.awt.SWT_AWT;
 import org.eclipse.swt.events.SelectionEvent;
 import org.eclipse.swt.events.SelectionListener;
 import org.eclipse.swt.layout.GridData;
@@ -22,172 +18,185 @@
 import org.txm.backtomedia.preferences.BackToMediaPreferences;
 import org.txm.utils.logger.Log;
 
-import uk.co.caprica.vlcj.discovery.NativeDiscovery;
-import uk.co.caprica.vlcj.discovery.linux.DefaultLinuxNativeDiscoveryStrategy;
-import uk.co.caprica.vlcj.discovery.mac.DefaultMacNativeDiscoveryStrategy;
-import uk.co.caprica.vlcj.discovery.windows.DefaultWindowsNativeDiscoveryStrategy;
-import uk.co.caprica.vlcj.player.MediaPlayer;
-import uk.co.caprica.vlcj.player.MediaPlayerEventAdapter;
-import uk.co.caprica.vlcj.player.MediaPlayerFactory;
+import uk.co.caprica.vlcj.factory.swt.SwtMediaPlayerFactory;
+import uk.co.caprica.vlcj.player.base.MediaPlayer;
+import uk.co.caprica.vlcj.player.base.MediaPlayerEventAdapter;
+import uk.co.caprica.vlcj.player.component.EmbeddedMediaPlayerComponent;
 import uk.co.caprica.vlcj.player.embedded.EmbeddedMediaPlayer;
-import uk.co.caprica.vlcj.player.embedded.videosurface.CanvasVideoSurface;
-import uk.co.caprica.vlcj.player.embedded.videosurface.VideoSurfaceAdapter;
-import uk.co.caprica.vlcj.player.embedded.videosurface.linux.LinuxVideoSurfaceAdapter;
-import uk.co.caprica.vlcj.player.embedded.videosurface.mac.MacVideoSurfaceAdapter;
-import uk.co.caprica.vlcj.player.embedded.videosurface.windows.WindowsVideoSurfaceAdapter;
+import uk.co.caprica.vlcj.player.embedded.videosurface.swt.CompositeVideoSurface;
 import vlcplayerrcp.MessagesMP;
 
 public class VLCPlayer extends Composite {
-	static {
-//		System.setProperty("jna.nosys", "true"); // TODO understand why I need to do this 
-//		NativeDiscovery nd = new NativeDiscovery(new DefaultLinuxNativeDiscoveryStrategy() {
-//			 @Override
-//			    protected void onGetDirectoryNames(List<String> directoryNames) {
-//			        directoryNames.add("/usr/lib");
-//			        directoryNames.add("/usr/local/lib");
-//			        directoryNames.add("/snap/vlc/current/usr/lib");
-//			    }
-//		},
-//	            new DefaultWindowsNativeDiscoveryStrategy(),
-//	            new DefaultMacNativeDiscoveryStrategy()
-//);
-		
-		if (!new NativeDiscovery().discover()) {
-			//System.out.println(MessagesMP.error_native_libs);
-		} else {
-			//System.out.println("VLC native libraries found !");
-		}
-	}
+	
+	// static {
+	//// System.setProperty("jna.nosys", "true"); // TODO understand why I need to do this
+	//// NativeDiscovery nd = new NativeDiscovery(new DefaultLinuxNativeDiscoveryStrategy() {
+	//// @Override
+	//// protected void onGetDirectoryNames(List<String> directoryNames) {
+	//// directoryNames.add("/usr/lib");
+	//// directoryNames.add("/usr/local/lib");
+	//// directoryNames.add("/snap/vlc/current/usr/lib");
+	//// }
+	//// },
+	//// new DefaultWindowsNativeDiscoveryStrategy(),
+	//// new DefaultMacNativeDiscoveryStrategy()
+	//// );
+	//
+	// if (!new NativeDiscovery().discover()) {
+	// //System.out.println(MessagesMP.error_native_libs);
+	// } else {
+	// //System.out.println("VLC native libraries found !");
+	// }
+	// }
 	protected static final String NOMEDIA = ""; //$NON-NLS-1$
-	private MediaPlayerFactory mediaPlayerFactory;
+	
 	private EmbeddedMediaPlayer vlcPlayer;
+	
 	private Composite videoComposite;
-	private CanvasVideoSurface playerCanvas;
+	
+	private CompositeVideoSurface playerCanvas;
+	
 	private Scale rateField;
+	
 	private Label rateValueLabel;
+	
 	private Scale volumeField;
+	
 	private Label volumeValueLabel;
 	
 	private Button playButton;
+	
 	private Button repeatButton;
 	
 	protected String currentlyPlayed = ""; //$NON-NLS-1$
-
-	//private String startTime, endTime;
+	
+	// private String startTime, endTime;
 	private int start, end;
 	
 	protected boolean hasEnded = false;
+	
 	private String previouslyPlayed = ""; //$NON-NLS-1$
+	
 	private boolean repeat = false;
+	
 	protected int volume = 100;
+	
 	private Button stopButton;
+	
 	Label timeLabel;
+	
 	TripleRangeSlider timeRange;
+	
 	boolean firstLengthEvent = true;
-
+	
 	long previous = 0;
+	
 	long time, mins, secs;
-
-
+	
+	private SwtMediaPlayerFactory factory;
+	
+	
 	static {
-		//uncomment to enable VLC logs
-		//Logger.setLevel(Level.TRACE);
+		// uncomment to enable VLC logs
+		// Logger.setLevel(Level.TRACE);
 	}
 	
 	public EmbeddedMediaPlayer getEmbeddedMediaPlayer() {
 		return vlcPlayer;
 	}
-
+	
 	public VLCPlayer(Composite parent, int style) {
 		super(parent, style);
 		this.setLayout(new GridLayout(11, false));
-
+		
 		// THE PLAYER
 		videoComposite = new Composite(this, SWT.EMBEDDED | SWT.NO_BACKGROUND);
-
-		Frame videoFrame = SWT_AWT.new_Frame(videoComposite);
-		Canvas canvas = new Canvas();
-		canvas.setBackground(java.awt.Color.black);
-		videoFrame.add(canvas);
-
-		mediaPlayerFactory = new MediaPlayerFactory();
-
-		vlcPlayer = mediaPlayerFactory.newEmbeddedMediaPlayer(null);
-		videoComposite.setVisible(true);
-
-		VideoSurfaceAdapter vadapter;
-		String OS = System.getProperty("os.name"); //$NON-NLS-1$
-		if (OS.indexOf("Windows") >= 0) { //$NON-NLS-1$
-			vadapter = new WindowsVideoSurfaceAdapter();
-		} else if (OS.indexOf("Mac") >= 0) { //$NON-NLS-1$
-			vadapter = new MacVideoSurfaceAdapter();
-		} else {
-			vadapter = new LinuxVideoSurfaceAdapter();
-		}
-
-		playerCanvas = new CanvasVideoSurface(canvas, vadapter);
-		vlcPlayer.setVideoSurface(playerCanvas);
-		vlcPlayer.setPlaySubItems(true); // for youtube, 2013-12-10: youtube.lua don't work
-
 		GridData gdata = new GridData(SWT.FILL, SWT.FILL, true, true);
-		gdata.horizontalSpan = 11;		
+		gdata.horizontalSpan = 11;
 		videoComposite.setLayoutData(gdata);
-
+		
+		factory = new SwtMediaPlayerFactory();
+		playerCanvas = factory.swt().newCompositeVideoSurface(videoComposite);
+		
+		EmbeddedMediaPlayerComponent e = new EmbeddedMediaPlayerComponent();
+		vlcPlayer = e.mediaPlayer();
+		vlcPlayer.videoSurface().set(playerCanvas);
+		
+		// videoComposite.addDisposeListener(new DisposeListener() {
+		// @Override
+		// public void widgetDisposed(DisposeEvent e) {
+		// vlcPlayer.controls().stop();
+		// vlcPlayer.release();
+		// factory.release();
+		// }
+		// });
+		
 		// THE CONTROL BUTTONS
-		playButton = new Button(this,SWT.PUSH);
+		playButton = new Button(this, SWT.PUSH);
 		GridData playLayoutData = new GridData(SWT.FILL, SWT.CENTER, false, false);
 		playButton.setLayoutData(playLayoutData);
 		playButton.setText(MessagesMP.play);
 		playButton.addSelectionListener(new SelectionListener() {
+			
 			@Override
 			public void widgetSelected(SelectionEvent e) {
-				if (currentlyPlayed.length() == 0) {
-					selectMedia();
-					playButton.setText(MessagesMP.pause);
-				} else	if (vlcPlayer.isPlaying()) {
-					vlcPlayer.pause();
-					playButton.setText(MessagesMP.resume);
-				} else if (hasEnded) {
-					replay();
-				} else {
-					vlcPlayer.play();
-					playButton.setText(MessagesMP.pause);
-				}
+				vlcPlayer.submit(new Runnable() {
+					
+					@Override
+					public void run() {
+						if (currentlyPlayed.length() == 0) {
+							selectMedia();
+							playButton.setText(MessagesMP.pause);
+						}
+						else if (vlcPlayer.status().isPlaying()) {
+							vlcPlayer.controls().pause();
+							playButton.setText(MessagesMP.resume);
+						}
+						else if (hasEnded) {
+							replay();
+						}
+						else {
+							vlcPlayer.controls().play();
+							playButton.setText(MessagesMP.pause);
+						}
+					}
+				});
 			}
-
+			
 			@Override
 			public void widgetDefaultSelected(SelectionEvent e) {}
 		});
-
-		//		Button browseButton = new Button(this,SWT.PUSH);
-		//		browseButton.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false));
-		//		browseButton.setText("Open...");
-		//		browseButton.addSelectionListener(new SelectionListener() {
-		//			@Override
-		//			public void widgetSelected(SelectionEvent e) {
-		//				selectMedia();			
-		//			}
+		
+		// Button browseButton = new Button(this,SWT.PUSH);
+		// browseButton.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false));
+		// browseButton.setText("Open...");
+		// browseButton.addSelectionListener(new SelectionListener() {
+		// @Override
+		// public void widgetSelected(SelectionEvent e) {
+		// selectMedia();
+		// }
 		//
-		//			@Override
-		//			public void widgetDefaultSelected(SelectionEvent e) {}
-		//		});
-
-		stopButton = new Button(this,SWT.PUSH);
+		// @Override
+		// public void widgetDefaultSelected(SelectionEvent e) {}
+		// });
+		
+		stopButton = new Button(this, SWT.PUSH);
 		stopButton.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false));
 		stopButton.setText(MessagesMP.stop);
 		stopButton.addSelectionListener(new SelectionListener() {
+			
 			@Override
 			public void widgetSelected(SelectionEvent e) {
 				stop();
 			}
-
+			
 			@Override
 			public void widgetDefaultSelected(SelectionEvent e) {}
 		});
-
+		
 		timeLabel = new Label(this, SWT.NONE);
 		timeLabel.setText("00:00"); //$NON-NLS-1$
-
+		
 		timeRange = new TripleRangeSlider(this, SWT.None);
 		timeRange.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false));
 		timeRange.setToolTipText(MessagesMP.time_range);
@@ -196,57 +205,58 @@
 			@Override
 			public void widgetSelected(SelectionEvent e) {
 				TripleRangeSlider.SELECTED_KNOB sk = timeRange.getLastSelectedKnob();
-				switch(sk) {
-				case UPPER:
-					end = timeRange.getUpperValue();
-					
-					if (end < time) {
-						//System.out.println("Upper changed: fix time");
-						time = end;
-						vlcPlayer.setTime(time);
-					}
-					break;
-				case LOWER:
-					start = timeRange.getLowerValue();
-					if (start > time) {
-						//System.out.println("Lower changed: fix time");
-						time = start;
-						vlcPlayer.setTime(time);
-					}
-					break;
-				case MIDDLE:
-					
-					time = timeRange.getMiddleValue();
-					//System.out.println("Middle changed: fix time: "+time);
-					vlcPlayer.setTime(time);
-					break;
-				default:
-					// nothing
+				switch (sk) {
+					case UPPER:
+						end = timeRange.getUpperValue();
+						
+						if (end < time) {
+							// System.out.println("Upper changed: fix time");
+							time = end;
+							vlcPlayer.controls().setTime(time);
+						}
+						break;
+					case LOWER:
+						start = timeRange.getLowerValue();
+						if (start > time) {
+							// System.out.println("Lower changed: fix time");
+							time = start;
+							vlcPlayer.controls().setTime(time);
+						}
+						break;
+					case MIDDLE:
+						
+						time = timeRange.getMiddleValue();
+						// System.out.println("Middle changed: fix time: "+time);
+						vlcPlayer.controls().setTime(time);
+						break;
+					default:
+						// nothing
 				}
-				//System.out.println("time range: "+start+" -> "+end+" time="+time);
+				// System.out.println("time range: "+start+" -> "+end+" time="+time);
 			}
 			
 			@Override
-			public void widgetDefaultSelected(SelectionEvent e) { }
+			public void widgetDefaultSelected(SelectionEvent e) {}
 		});
-
-		repeatButton = new Button(this,SWT.CHECK);
+		
+		repeatButton = new Button(this, SWT.CHECK);
 		repeatButton.setText(MessagesMP.repeat);
 		repeat = BackToMediaPreferences.getInstance().getBoolean(BackToMediaPreferences.REPEAT);
 		repeatButton.setSelection(repeat);
 		repeatButton.addSelectionListener(new SelectionListener() {
+			
 			@Override
 			public void widgetSelected(SelectionEvent e) {
 				repeat = repeatButton.getSelection();
 			}
-
+			
 			@Override
-			public void widgetDefaultSelected(SelectionEvent e) { }
+			public void widgetDefaultSelected(SelectionEvent e) {}
 		});
-
+		
 		Label l = new Label(this, SWT.NONE);
 		l.setText(MessagesMP.rate);
-
+		
 		rateField = new Scale(this, SWT.BORDER);
 		GridData gdata4 = new GridData(SWT.FILL, SWT.CENTER, false, false);
 		gdata4.widthHint = 100;
@@ -255,25 +265,26 @@
 		rateField.setMinimum(70);
 		rateField.setSelection(100);
 		rateField.setPageIncrement(5);
-
+		
 		rateField.addSelectionListener(new SelectionListener() {
+			
 			@Override
 			public void widgetSelected(SelectionEvent e) {
-				float rate = rateField.getSelection()/100.0f;
-				vlcPlayer.setRate(rate);
-				rateValueLabel.setText(""+rateField.getSelection()+"%");
+				float rate = rateField.getSelection() / 100.0f;
+				vlcPlayer.controls().setRate(rate);
+				rateValueLabel.setText("" + rateField.getSelection() + "%");
 			}
-
+			
 			@Override
-			public void widgetDefaultSelected(SelectionEvent e) { }
+			public void widgetDefaultSelected(SelectionEvent e) {}
 		});
-
+		
 		rateValueLabel = new Label(this, SWT.NONE);
 		rateValueLabel.setText("100%");//$NON-NLS-1$
 		
 		l = new Label(this, SWT.NONE);
 		l.setText(MessagesMP.volume);
-
+		
 		volumeField = new Scale(this, SWT.BORDER);
 		gdata4 = new GridData(SWT.FILL, SWT.CENTER, false, false);
 		gdata4.widthHint = 100;
@@ -283,124 +294,158 @@
 		volumeField.setSelection(volume);
 		volumeField.setPageIncrement(5);
 		volumeField.addSelectionListener(new SelectionListener() {
+			
 			@Override
 			public void widgetSelected(SelectionEvent e) {
-				vlcPlayer.setVolume(volumeField.getSelection());
+				vlcPlayer.audio().setVolume(volumeField.getSelection());
 				volume = volumeField.getSelection();
-				volumeValueLabel.setText(""+volume+"%");
+				volumeValueLabel.setText("" + volume + "%");
 			}
-
+			
 			@Override
-			public void widgetDefaultSelected(SelectionEvent e) { }
+			public void widgetDefaultSelected(SelectionEvent e) {}
 		});
 		
 		volumeValueLabel = new Label(this, SWT.NONE);
 		volumeValueLabel.setText("100%");
-
-		vlcPlayer.addMediaPlayerEventListener(new MediaPlayerEventAdapter() {			
+		
+		vlcPlayer.events().addMediaPlayerEventListener(new MediaPlayerEventAdapter() {
+			
 			@Override
 			public void playing(MediaPlayer mediaPlayer) {
-				if (volumeField != null) {
-					vlcPlayer.setVolume(volume);
-				}
+				mediaPlayer.submit(new Runnable() {
+					
+					@Override
+					public void run() {
+						if (volumeField != null) {
+							vlcPlayer.audio().setVolume(volume);
+						}
+					}
+				});
 			}
-
+			
 			@Override
 			public void finished(MediaPlayer mediaPlayer) {
-				if (repeat) {
-					replay();
-				} else {
-					hasEnded = true;
-				}
+				mediaPlayer.submit(new Runnable() {
+					
+					@Override
+					public void run() {
+						if (repeat) {
+							replay();
+						}
+						else {
+							hasEnded = true;
+						}
+					}
+				});
+				
 			}
 		});
-
-		vlcPlayer.addMediaPlayerEventListener(new MediaPlayerEventAdapter() {
-
+		
+		vlcPlayer.events().addMediaPlayerEventListener(new MediaPlayerEventAdapter() {
+			
 			@Override
-			public void timeChanged(MediaPlayer arg0, final long arg1) {
-				time = arg1;
-				if (previous == time) {
-					return;
-				}
-				previous = time;
-
-				timeLabel.getDisplay().syncExec(new Runnable() {
+			public void timeChanged(MediaPlayer mediaPlayer, final long arg1) {
+				
+				mediaPlayer.submit(new Runnable() {
+					
 					@Override
 					public void run() {
-						if (timeRange.isDisposed()) {
+						time = arg1;
+						if (previous == time) {
 							return;
 						}
-						if (!timeRange.isDragMiddleKnob()) {
-							timeRange.setMiddleValue((int)time);
-						}
-						updateTimeLabel();
+						previous = time;
 						
-						if (arg1 > end && end != start) {
-							//System.out.println("Time > end :"+arg1 +" > "+end);
-							if (repeat) {
-								vlcPlayer.setTime(start);
-							} else {
-								vlcPlayer.stop();
+						timeLabel.getDisplay().syncExec(new Runnable() {
+							
+							@Override
+							public void run() {
+								if (timeRange.isDisposed()) {
+									return;
+								}
+								if (!timeRange.isDragMiddleKnob()) {
+									timeRange.setMiddleValue((int) time);
+								}
+								updateTimeLabel();
+								
+								if (arg1 > end && end != start) {
+									// System.out.println("Time > end :"+arg1 +" > "+end);
+									if (repeat) {
+										vlcPlayer.controls().setTime(start);
+									}
+									else {
+										vlcPlayer.controls().stop();
+									}
+								}
 							}
-						}
+						});
 					}
 				});
 			}
-
+			
 			@Override
-			public void lengthChanged(MediaPlayer arg0, final long arg1) {
-				if (firstLengthEvent) {
-					firstLengthEvent = false;
+			public void lengthChanged(MediaPlayer mediaPlayer, final long arg1) {
+				
+				mediaPlayer.submit(new Runnable() {
 					
-					//initialize time range widget limits
-					timeRange.getDisplay().syncExec(new Runnable() {
-						@Override
-						public void run() {
-							if (timeRange.isDisposed()) return;
-							timeRange.setMaximum((int)arg1);
-							//if (start == end) end = (int)arg1;
+					@Override
+					public void run() {
+						if (firstLengthEvent) {
+							firstLengthEvent = false;
 							
-							
-							if (end > 0 && start != end) {
-								timeRange.setUpperValue(end);
-							} else {
-								timeRange.setUpperValue((int)arg1);
-							}
-							
-							timeRange.setLowerValue(start);
-							//System.out.println("Range: "+start+" -> "+end+" song length "+arg1);
+							// initialize time range widget limits
+							timeRange.getDisplay().syncExec(new Runnable() {
+								
+								@Override
+								public void run() {
+									if (timeRange.isDisposed()) return;
+									timeRange.setMaximum((int) arg1);
+									// if (start == end) end = (int)arg1;
+									
+									
+									if (end > 0 && start != end) {
+										timeRange.setUpperValue(end);
+									}
+									else {
+										timeRange.setUpperValue((int) arg1);
+									}
+									
+									timeRange.setLowerValue(start);
+									// System.out.println("Range: "+start+" -> "+end+" song length "+arg1);
+								}
+							});
 						}
-					});
-				}
+					}
+				});
 			}
 		});
 	}
-
+	
 	private void updateTimeLabel() {
 		mins = time / 60000;
 		secs = (time / 1000) % 60;
 		timeLabel.setText(String.format("%02d:%02d", mins, secs)); //$NON-NLS-1$
 		timeLabel.update();
 	}
-
+	
 	protected void replay() {
 		if (currentlyPlayed.length() > 0) {
-			//this.play(currentlyPlayed, startTime, endTime);
-			vlcPlayer.setTime(start);
+			// this.play(currentlyPlayed, startTime, endTime);
+			vlcPlayer.controls().setTime(start);
 			playButton.setText(MessagesMP.pause);
 		}
 	}
-
+	
 	protected void selectMedia() {
 		Log.fine(MessagesMP.select_file);
-
+		
 		FileDialog fd = new FileDialog(VLCPlayer.this.getShell(), SWT.OPEN);
 		fd.setText(MessagesMP.select_file_title);
 		File f = new File(previouslyPlayed);
 		if (f.isDirectory()) fd.setFilterPath(f.getPath());
 		else fd.setFilterPath(f.getParent());
-
+		
 		String[] filterExt = { "*.*", "*.mp3", "*.mp4", "*.avi" }; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
 		fd.setFilterExtensions(filterExt);
 		String selected = fd.open();
@@ -408,14 +453,13 @@
 			System.out.println(MessagesMP.cancel);
 			return;
 		}
-
+		
 		currentlyPlayed = selected;
 		previouslyPlayed = selected;
-		Log.fine(MessagesMP.opening+currentlyPlayed);
+		Log.fine(MessagesMP.opening + currentlyPlayed);
 		play(currentlyPlayed, 0, 0);
-
 	}
-
+	
 	/**
 	 * 
 	 * @param mrl
@@ -423,21 +467,22 @@
 	 * @param endtime msec end time
 	 */
 	public void play(String mrl, int time, int endtime) {
-		Log.fine(MessagesMP.bind(MessagesMP.playing, new Object[]{mrl, time, endtime}));
-		play(mrl, ""+time/1000.0f, ""+endtime/1000.0f); //$NON-NLS-1$ //$NON-NLS-2$
+		Log.fine(MessagesMP.bind(MessagesMP.playing, new Object[] { mrl, time, endtime }));
+		play(mrl, "" + time / 1000.0f, "" + endtime / 1000.0f); //$NON-NLS-1$ //$NON-NLS-2$
 	}
-
+	
 	public void play(String mrl, int time) {
 		play(mrl, time, time);
 	}
-
+	
 	public void hideStopButton() {
 		if (this.stopButton != null && !this.stopButton.isDisposed()) {
 			this.stopButton.dispose();
 		}
 	}
-
+	
 	DateTimeFormatter hhmmssFormatter = DateTimeFormatter.ISO_LOCAL_TIME;
+	
 	/**
 	 * 
 	 * @param mrl
@@ -445,47 +490,55 @@
 	 * @param endTime "0.0" or ""hh:mm:ss" format
 	 */
 	public void play(String mrl, String startTime, String endTime) {
-
+		
 		if (startTime.matches("[0-9]+.[0-9]+")) {
-			start = (int)(1000*Float.parseFloat(startTime));
-		} else if (startTime.matches("[0-9]+:[0-9]+:[0-9]+")) {
+			start = (int) (1000 * Float.parseFloat(startTime));
+		}
+		else if (startTime.matches("[0-9]+:[0-9]+:[0-9]+")) {
 			if (startTime.indexOf(":") == 1) {
-				startTime = "0"+startTime;
+				startTime = "0" + startTime;
 			}
 			LocalTime time1 = LocalTime.parse(startTime, hhmmssFormatter);
-			start = 1000*((time1.getHour()*60*60) + (time1.getMinute()*60) + time1.getSecond());
+			start = 1000 * ((time1.getHour() * 60 * 60) + (time1.getMinute() * 60) + time1.getSecond());
 		}
 		
 		if (endTime.matches("[0-9]+.[0-9]+")) {
-			end = (int)(1000*Float.parseFloat(endTime));
-		} else if (endTime.matches("[0-9]+:[0-9]+:[0-9]+")) {
-			if (endTime.indexOf(":") == 1) endTime = "0"+endTime;
+			end = (int) (1000 * Float.parseFloat(endTime));
+		}
+		else if (endTime.matches("[0-9]+:[0-9]+:[0-9]+")) {
+			if (endTime.indexOf(":") == 1) endTime = "0" + endTime;
 			LocalTime time1 = LocalTime.parse(endTime, hhmmssFormatter);
-			end = 1000*((time1.getHour()*60*60) + (time1.getMinute()*60) + time1.getSecond());
+			end = 1000 * ((time1.getHour() * 60 * 60) + (time1.getMinute() * 60) + time1.getSecond());
 		}
 		
-		//if (start == end) end = -1;
+		// if (start == end) end = -1;
 		
-		Log.fine(MessagesMP.bind(MessagesMP.playing, new Object[]{mrl, startTime, endTime}));
-		vlcPlayer.playMedia(mrl);
-		vlcPlayer.setTime(start);
-		if (new File(mrl+".srt").exists()) { //$NON-NLS-1$
-			vlcPlayer.setSubTitleFile(mrl+".srt"); //$NON-NLS-1$
+		Log.fine(MessagesMP.bind(MessagesMP.playing, new Object[] { mrl, startTime, endTime }));
+		// vlcPlayer.submit(new Runnable() {
+		//
+		// @Override
+		// public void run() {
+		vlcPlayer.media().play(mrl);
+		vlcPlayer.controls().setTime(start);
+		if (new File(mrl + ".srt").exists()) { //$NON-NLS-1$
+			vlcPlayer.subpictures().setSubTitleFile(mrl + ".srt"); //$NON-NLS-1$
 		}
 		currentlyPlayed = mrl;
 		previouslyPlayed = mrl;
 		
 		playButton.setText(MessagesMP.pause);
 		firstLengthEvent = true;
+		// }
+		// });
 	}
-
+	
 	public void setRepeat(boolean repeat) {
 		this.repeat = repeat;
 		repeatButton.setSelection(repeat);
 	}
-
+	
 	public void stop() {
-		vlcPlayer.stop();
+		vlcPlayer.controls().stop();
 		currentlyPlayed = NOMEDIA;
 		if (!playButton.isDisposed()) {
 			playButton.setText(MessagesMP.play);
